














                               PCbug11 User's Manual



                                       V3.2















The information in this document has been carefully checked and is
believed to be entirely reliable. However, no responsibility is assumed
for inaccuracies. Furthermore, Motorola reserves the right to make
changes to the product herein to improve reliability, function, or
design. Motorola does not assume any liability arising out of the
application or use of any product or circuit described herein; neither
does it convey any license under its patent rights or the rights of
others. Motorola products are not authorised for use as components in
life support devices or systems intended for surgical implant into the
body or intended to support or sustain life. Buyer agrees to notify
Motorola of such intended end use whereupon Motorola shall determine the
availability and suitability of its products for the use intended

                         Copyright (c) Motorola Ltd 1990

Contents


Title          Page

1. Introduction to PCbug11                                  2

2. Setting up your M68HC11 for use with PCbug11             3

3. Starting PCbug11 with your hardware                      4
     3.1 Running the software                               4
     3.2 The PCbug11 monitor screen                         5
     3.3 Fixing simple problems and trying simple commands  6

4. How PCbug11 works                                        8

5. Using the Software                                       10
     5.1 PCbug11 Runtime Command Structure                  10
     5.2 Uses of the Software                               12
     5.3 Pitfalls to avoid                                  12

6. PCbug11 Commands                                         14
     6.1 Command line editing                               14
     6.2 Monitor  Commands                                  14
          6.2.1 PCbug11 Command Summary                     15
          6.2.2 PCbug11 Command Description                 17

7 Advanced Topics                                           43
     7.1 Macros                                             43
          7.1.1 Defining Macros                             44
          7.1.2 Editing Macros                              45
          7.1.3 Listing and Clearing Macros                 46
     7.2 Using Trace and Breakpoints                        46
     7.3 Talkers in EEPROM or External Memory               47
     7.4 Programming EPROM (711) parts                      49
     7.5 Designing new talkers                              50
     

Appendices                                                  51
A - Circuit Diagram and Components List                     51
     A.1 Components List                                    51
     A.2 Circuit Diagram                                    52

B - PCbug11 Error messages                                  53
     B.1 Operation Errors                                   53
     B.2 Communications Errors and other Fatal Errors       53
     B.3 Command Errors                                     55

C - PCbug11 Disk Contents                                   56

D - Software Version Information                            57





1. Introduction to PCbug11

PCbug11 is a software package designed to allow easy access to and
simple experimentation with M68HC11 family members.

The package allows users to program the 68HC11 of interest and also to
examine the behaviour of internal peripherals under specific conditions.
In addition user programs may be run on the part with breakpoint and
trace processing available.

This manual provides information on installing and running the program
and on common problems encountered. The user is advised to review any
attached version information note before proceeding with the code.




Terminology:

M68HC11, HC11       Any member of the 68HC11 family of processors

A8, E9, D3 etc.     A particular family member - normally preceded
                    by MC68HC(7)11..



















The following are trademarks:
     MS-DOS is a registered trademark of Microsoft Corporation
     IBM is a registered trademark of International Business Machines
     Corporation
     Motorola and (batwing) are registered trademarks
2. Setting up your 68HC11 for use with PCbug11

There are two steps in preparing your 68HC11 for use with PCbug11.
Firstly the hardware support components must be prepared and secondly
the software must be run on your IBM or compatible PC. Appendix A deals
with the hardware construction and lists the components required.

The software may be installed on to a hard disk as follows:

1) PCbug11 is supplied on a single 360KB disk.

2) Insert disk into floppy drive of the PC.

3) Create a new directory to contain PCbug11 files - say PCBUG11

4) Copy all the files on the disk onto the hard disk directory using the
COPY or XCOPY commands.

5) Once successfully installed the monitor may be run from anywhere in
the PC directory structure if the DOS PATH command is correctly set up.

6) Note that the software may be run from the floppy drive assuming all
the appropriate files are available.

3. Starting PCbug11 with your hardware

Using the software package is simply a case of setting up the hardware,
connecting it  to the PC communications port, and running the monitor
program PCbug11.

3.1 Running the software

PCbug11 is a highly sophisticated piece of software which may take many
options depending on the 68HC11 family member, PC port used, crystal
used and if any macros are to be used on startup. However, in the
simplest case the command to startup the software is as follows:

     PCBUG11 -XA

This will start up a 68HC11A8/1/0 with the XIRQ pin connected to the PD0
pin.

It is also possible to use other 68HC11 family members. To use other
family members the two characters after the -X in the command line is
altered. This character is associated with the type of bootloader used
on the chip. Most HC11s use the E9 type bootloader so that the -XE
option will suit most family members. The following table highlights the
current possibilities :

Device    PCbug11 startup command

68HC11A8) 
68HC11A1 )     PCBUG11 -XA
68HC11A0)

68HC11E9)
68HC11E1 )     PCBUG11 -XE
68HC11E0)

68HC811A2      PCBUG11 -XE

68HC811A8      PCBUG11 -88

68HC(7)11D3    PCBUG11 -D

68HC711E9      PCBUG11 -E

68HC11F1       PCBUG11 -XE

68HC(7)11K4    PCBUG11 -K

Type the command shown above which corresponds to the device which you
have installed on your hardware. Note that if the X option is indicated
then the XIRQ pin should be connected to the PD0/Rx pin.
3.2 The PCbug11 monitor screen

The status of the hardware is displayed on the screen of the PC. There
are four major areas or "windows" which make up this screen.

     1) The command window is situated at the bottom left of the PC
screen. On colour screens it has a black background and white text. It
is in this window that commands to the package are entered and
displayed. The command cursor which is part of this window appears on
the bottom line of the screen and is indicated by a  character. When
commands are typed in they will appear after this cursor. The rest of
the window is used to display previous commands and indicate last error
messages.

     2) The status window is situated to the middle right of the screen.
On colour screens this is shown with a purple background and white text.
This shows the current 68HC11 processor being used, its state
(running,stopped,tracing), the status of the RS232 RTS line and the
current user set interrupt vectors.

     3) The register window is displayed in the middle of the screen. It
is shown with a red background and white or yellow text. This window
displays the last recorded contents of the processor registers. It is
important to note that this window is only updated on startup and when
requested by the user. The contents of the registers may be modified by
using PCbug11 commands.

     4) The main window occupies the upper half of the screen and has a
blue background with white text. This window is used to display most
information about the package. It shows the results of commands, memory
contents, assembly opcodes, macros and many other items concerned with
the operation of the package.

In addition to the above windows a temporary window is used to indicate
any errors and whether the communications to the HC11 are operating
normally. This is displayed on top of the main window contents and on a
colour screen is shown as red characters on a black background. This
error window is cleared by hitting any key or after a timeout of around
5 seconds.

If the screen as described above does not appear then the program has
not run properly. A DOS or a PCbug11 error message (in the error window)
will describe what the problem is. Please correct this error before
proceeding. The following section gives some help if errors occur.

3.3 Fixing simple problems and trying simple commands

If the software did not start up properly then errors will be displayed
on the command screen and the register window will show  a series of
XX's where the register values should be. A detailed description of the
meaning of these errors is contained in Appendix B, however, it is
likely that for an initial start up that the errors are due to either
the communications link or some incorrect setting on the hardware. Check
the following:

     1. 5V connected correctly to board.
     2. An 8MHz crystal installed in the circuit.
     3. Communications cable correctly wired.
     4. 68HC11 in bootstrap mode and properly reset
     5. Cable connected to port COM1 of the PC (COM 2 can be used, see
section 5.1).

Try all the above then retry starting the system. If the system
continues to fail then it is best to check the hardware constructed and
the HC11 itself before calling for help.

If you had no error messages and the register display contains digits
then the package is working correctly.

The full command set for PCbug11 is contained in section 2.6, but we
shall look at some simple commands to demonstrate the operation of the
package.

1) To ensure that communications between the board and the PC are
operational the command ^R (<CTRL> and R keys pressed simultaneously) is
supplied. If the communications are ok then

          Communications synchronised

appears in the main window. If there is a fault then

          Communications fault

appears in the main window.

2) If at anytime a communications fault is shown (either after pressing
^R or by another operation) then it is probably best to restart the
package once the checklist above has been followed. To restart the
package while it is running simply type

          RESTART

This has the effect of causing the communications program to be reloaded
and allows you to start afresh. Note : this command will only work if
you reset the HC11 before typing the command. This command may cause any
program in RAM on the processor to be lost.

3) To finish a session with the package the command is

          QUIT

A message in the main window will ask you to confirm this before the
program is terminated on the PC.

4) Reading the contents of the processor registers is done by typing

          RD

If the command is successful the register contents will be displayed. If
not then an error message will be shown and the register window will
contain X's.

5) Displaying the contents of memory can be done by the
          
          MD start_address (end_address)

command. The two values start_address and end_address indicate the block
of memory to be displayed. If end_address is not entered then the 16
locations from start_address will be shown. Note that all hexadecimal
numbers within PCbug11 are indicated by a leading $.If the contents are
correctly read then they will displayed on the main window. If not then
an error message will be displayed.

6) The main window may be cleared by the command CLS.

7) A user help function is available if the help file has been
installed. To see a summary of the commands available type

          HELP

Help on a particular command may be available. To see this type

          HELP command

where command is the command of interest.

The operation of more complex commands is shown in section 6.2


4. How PCbug11 works

To fully appreciate both the power and the limitations of the PCbug11,
it is important to understand how the system works. This section
describes the basic operation of the package. It is strongly advised
that the reader examines this section before going on to more complex
commands.

Most microcomputer emulators/trainers work in a similar manner. The
microcomputer chip will run a program in ROM which communicates with a
terminal allowing the user to execute program and alter registers etc.
This monitor program is generally sophisticated and requires a complex
hardware platform, although no other computer equipment (except a
terminal) need be attached except when higher level functions such as
high level debug etc. are used.

With this package the approach is quite different. In this case the
microcomputer runs only a very simple program. All the sophistication is
at the PC which has a serial connection to the board. The communication
between the PC and the HC11 allows similar functions to that of the
emulator to be carried out with a very much simpler hardware board. In
effect the hardware complexity of the emulator has been replaced with
software complexity on the PC.

PCbug11 communicates with the 68HC11 through a low level communication
program called the talker. A number of different talkers are supplied to
support different HC11's and operating modes. All of these talkers are
designed to communicate through the HC11's SCI port to the PC's serial
port.

Each talker occupies less than 256 bytes of 68HC11 memory space and
operates under interrupt. However, the operation of the talkers can be
divided into two main groups: those talkers which use internal HC11 RAM
memory and those talkers which use internal EEPROM or other ROM.

In the first case the PC must download the talker into the the HC11's
RAM each time the hardware is used. In the latter the PC simply
synchronises communication with the talker program which is already
running on the HC11. Both approaches have advantages and disadvantages
and are discussed below. The RAM approach is termed the boot method and
the alternative is called the ROMed method.

In the boot method, a talker is downloaded into the 68HC11's internal
RAM during the start up of PCbug11. This download is achieved by using a
special mode of the HC11 called bootstrap mode. In this mode it is
possible to have the HC11 automatically download a program into its
internal RAM and then run that program. This makes it possible to alter
internal values, program memory, read and write to chip ports and other
functions. This approach is very simple and requires no external
hardware around an HC11 except a power supply, an oscillator and an
interface to the RS232. It is limited in that it does use around 240
bytes of the internal RAM (less for the D3 part). This may be a problem
for some users.

In ROMed mode, the appropriate Talker must be preprogrammed into either
internal or external 68HC11 memory space, before PCbug11 is run on the
PC. In the simplest case the talker is placed in an external memory and
is run whenever the HC11 is powered up. A compromise is possible if a
talker is loaded into the HC11's internal EEPROM.

Since the Talker is interrupt driven, and resides in the same memory map
as user software, certain vectors must be reserved for the Talker code.
These are the RESET, XIRQ, and SWI vectors. However, the SCI vector may
be used in preference to the XIRQ vector, to give maskable control to
PCbug11.

Given the operating approach of PCbug11 described above some rules of
thumb become apparent.

1) PCbug11 in boot mode uses HC11 internal RAM for its talker program.
Also in RAM are the interrupt vectors used in bootstrap mode and the
program stack. In an HC11 with 256 bytes of RAM this leaves little room
for any user program in RAM. Here the user is advised to program in
EEPROM.

2) PCbug11 is interrupt driven. Therefore any user program which uses
interrupts should be carefully considered. The standard approach uses
the XIRQ pin to cause an interrupt whenever communications are required
by the user. So interrupts which set the I bit may be used reasonably
freely. However, breakpoint and trace operations also use the I bit (see
point 3) so care should be taken. Breakpoint and trace are not available
with the D3/0.

3) PCbug11 implements trace and breakpoint by placing a software
interrupt at the location where the trace/breakpoint is required. This
means that the code at the location must be modifiable by PCbug11 i.e.
it must be either RAM or EEPROM (internal or external). The program
cannot operate trace or breakpoints on ROM. This restriction also
applies to FLASH memory as they are not byte programmable. Note that any
user defined SWI will be handled correctly with a little extra software
overhead.

The approach taken by PCbug11 is a simple one requiring little hardware,
however, the user must be aware of its operation in order to fully
utilise the system.


5. Using the Software

The object of this section is to introduce the user to some of the
possibilities for using the software. Firstly, the various ways in which
PCbug11 can be initialised will be discussed and then some typical uses
and pitfalls will be explored.

5.1 PCbug11 Runtime Command Structure

To the user PCbug11 presents a large range of possibilities for use.
This section deals with the command which is typed at the DOS prompt.
The syntax for this command is :-

PCBUG11 [?|[-X][talker][macro=macroname params][baud=baudrate][port=1|2]

<talker> = <boottype>|<ROMtype>
<boottype> = A|D|E|K|88|<user defined>
<ROMtype> = user defined file for ROMed talker

<baudrate> = a number which is a possible baud rate for the PC and for
          the HC11

<macroname> = A valid name for a macro file which is stored in the
               current directory

KEY: 
     <talker_type> indicates which talker is to be used. If this field
is preceded by the - character then the file TALK<boottype>.BOO/.XOO
must be in the same directory as PCbug11.exe.
     <ROMtype> indicates that a ROMed talker is in use and the user must
supply a file called <ROMtype>.MAP in the current directory.
     <baud> is only applicable when a crystal other than 8MHz is being
used. At this frequency the communications rate which the PC uses is
9600 baud and the rate at which the -<name> talker is downloaded is
7812. Users using alternative crystals must inform PCbug11 what ratio
this is to 8MHz by using the <baud> option. For the <boottype> option,
<baudrate> is the baud rate that will be used by the PC and the HC11 for
communications, it must be a value which represents the same ratio to
9600 as the crystal in use represents to 8MHz That is,

     <baud> =  crystal_used MHz  * 9600   (for <ROMtype>)
               ----------------
                      8

If the <boottype> option is in use then <baudrate> must be the value
which represents the same ratio to 7812 as the crystal in use represents
to 8MHz. That is

     <baud> =  crystal_used MHz  * 7812   (for <boottype>)
               ---------------
                      8

     <macroname> is the name of a macro library file i.e.
<macroname>.MCR which is automatically loaded at startup. This is useful
because if a macro called AUTOSTART exists in this library then it will
executed automatically after startup. Parameters may be passed to this
macro by enclosing them in round brackets () immediately after the
macro= option.

     port=2 indicates that the PC port to be used for communications
with the hardware is port 2 and not port 1 which is the default port.

Examples of use of runtime command:

Command = PCBUG11   (No options)

This command causes the Command Line Compiler (CLC) to be invoked. This
allows the user to construct a command line by answering certain
questions related to what the options are required. Inexperienced users
may find this useful when swapping from one HC11 to another or wishing
to try a new option.

Command = PCBUG11 ?   (query option)

The query option simply displays a short form of the runtime command
line syntax. Useful as a quick reminder.

Command = PCBUG11 -XE   (E/F/G/L series)

This simple command causes a suitable HC11 to run a boot option talker.
The talker is downloaded into RAM and then run.

Command = PCBUG11 -XA port=2   (A/E2 using port 2 option)

This command downloads the HC11A8 type boot talker except that it uses
serial port 2 on the PC if it exists. The talker is loaded into RAM and
run from there.

Command = PCBUG11 -XE TRYIT   (E/F/G/L series and macro load option)

Here the boot option talker is loaded into a suitable RAM and the macro
library file TRYIT.MCR is loaded. If the macro AUTOSTART is present then
it is run automatically.

Command = PCBUG11 TALKEREE baud=4800 macro=LISTIT   (talker ,baud and
macro load)

The talker called talkeree.S19 has been pre-loaded into the HC11
already. This command starts up this talker and loads the macro library
file LISTIT.MCR. NOTE for this talker to work correctly PCbug11 must be
able to load the file TALKEREE.MAP which contains essential system
variables - section 7.3 for more details. This file must be in the
current active directory. The crystal on the talker board is 4MHz.

5.2 Uses of the Software

The list of possibilities for the software is unlimited. This is not a
clever software simulation of a 68HC11, the commands and programs you
enter will run on the real hardware, albeit via a software interface.
Since most of the time the hardware will be running the HC11 in special
bootstrap mode access to secured resources is at the user's discretion
and not under HC11 control. (This applies once the HC11 is started, in
starting the part any installed program may be erased)

Since the package runs under interrupt. It is possible to have a program
running and still be able to read registers etc. It is also possible to
write to registers and even to memory. With care it is even possible to
modify the program that is being run at that time. The user should note
that while the program or registers are being modified the program in
use actually waits while the interrupt caused by PCbug11 is processed.

Breakpoints can be set in the software to cause the 68HC11 to stop
whenever a point in the code is reached. The trace command also allows
the user to step through code to see how instructions are executed and
what result they have on the registers and CCR.

PCbug11 allows the user to modify and assemble into EEPROM as if it were
RAM. Although the 68HC11 has quite an elaborate routine required to
program this memory, PCbug11 handles the algorithm so that programming
can be carried out transparently. The area of internal EEPROM must be
predefined using the EEPROM command before PCbug11 can program it
correctly. Note that external EEPROM should not be specified in this way
since the talker will automatically handle slow external memories. The
user will notice a difference in response time between writing to EEPROM
and RAM.

5.3 Pitfalls to avoid

Just as a feature of PCbug11 is being able to program EEPROM
transparently, there is also a side issue. On some HC11 there is a
register which adds even more protection to the EEPROM memory. This is
called the BPROT register and generally resides at address $1035. This
must be modified before the EEPROM or CONFIG register can be programmed.
PCbug11 DOES NOT modify this register.

If programming the CONFIG register it should be remembered that the
contents of this register are generally not readable until the HC11 has
been reset. Note also that if the part is reset in bootstrap mode
certain automatic functions are carried out to place the part in a
sensible operating mode. So the user will  find that the NOCOP bit will
always read 1 in bootstrap mode even if it has been programmed
otherwise. If it is a security mode part then clearing the NOSEC bit
will protect the internal RAM, EEPROM and CONFIG register. This means
that if the part is reset in bootstrap mode then the CONFIG register
will read $0F. If it didn't then the security mode would not be
operating!

The use of interrupts is possible with the hardware, but certain
practices must always be followed. For interrupts such as the real time
interrupt etc., the interrupt is allowed by the I bit being clear and
the appropriate interrupt mask being set (e.g. RTII bit for the real
time interrupt). Note that while the interrupt flag I is set by an
interrupt and cleared by a CLI (or RTI) instruction, the flag for the
interrupt source itself remains set (for the real time interrupt this is
RTIF). So an exit from a real time interrupt service routine which
leaves RTIF set will cause an interrupt to occur again immediately and
communications with PCbug11 could cease (due to stack overflow) or cease
to make sense. This has often been seen as a bug with PCbug11, but a
casual analysis shows the user at fault. The user must clear the local
interrupt flag (e.g. RTIF for the real time interrupt).

When real time measurements and calculations are in progress, it is
necessary to remember that by reading registers or memory, the user is
causing interrupts which interfere with the logical operation of the
program. This could cause the result of the code to be upset in such a
way that the answer is wrong. This is particularly the case when the
processor is waiting for the logical value on a port pin to change
before carrying out some action. If the change occurs while the user is
using PCbug11 to enquire about the processor status then the change
could be lost or upset. Remember that the 68HC11 itself does its own
self examination, it does not rely on external hardware for this
function. Programs which perform off-line functions such as calculations
will not, of course, be affected by this action.

Breakpoints and traces are implemented by the package via software
interrupts (SWI). This means that when a breakpoint is hit an interrupt
is generated which is handled by the internal talker. If the SWI is the
used by the user directly then the SWI vector is called. If it is a true
breakpoint then the PC performs various actions to inform the user. This
system which is used by many emulators is very effective, but
unfortunately is limited to use with RAM or EEPROM. ROM cannot have
breakpoints set in it nor can it be traced through. Another problem
exists when resetting the device while all breakpoints are still set.
When the user resets or restarts the SWIs will remain in memory
(especially EEPROM). These will be displayed as SWIs where normally
another opcode would be displayed. The moral is either clear all
breakpoints before resetting or restarting the device or load your code
in again before using it after a reset/restart.

Finally, a point about macros. These are implemented such that their
execution by PCbug11 can be very quick. A practice which may therefore
cause problems is to place a G command in a macro followed by certain
other commands which modify memory associated with the program. Since
there is no way of knowing where the program is in its execution, a
macro may modify memory before or during  the program's own memory
operation (remember that PCbug11 commands operate under interrupts, in
which case the program is temporarily halted). Since memory operations
normally involve loading/calculating a value and then storing it in
memory, it is possible that the load/calculation could be performed and
then an interrupt could occur during which PCbug11 could set the value
of that location. On ending the interrupt the program would then store
into the memory location. This could cause apparently erroneous
operation and error messages. Therefore, it is not advisable to have a G
instruction in a macro followed by instructions which modify memory.

Note that different boot talkers initialise the stack to different
values according to the availability of RAM. Therefore the user take
care when moving from one processor to another where the stack pointer
varies. The default values are:

A - $EB; D - $EB; E - $1FF; K - $1FF; 88 - $EB
6. PCbug11 Commands

6.1 Command line editing

PCbug11's command line can be edited using a number of keys on the host
computer. In addition there is a recall buffer which holds the last 16
commands entered. The following keys provide the edit and recall
features:

left arrow     - move cursor back 1 character
right arrow    - move cursor forward 1 character
Home           - move cursor to first character
End            - move cursor to last character
delete left    - delete to left of cursor
Del            - delete at cursor position
CTRL End       - delete from cursor position to end of line
Ins            - insert at cursor position (cursor changes to blocked
               cursor)
up arrow       - recall last entered command
down arrow     - recall last command in recall buffer
Esc            - Clear command line

In addition, the Esc key can be used to terminate most commands in
progress. e.g. MD, DASM, ASM.
The 4 lines above the command line provide a trace of  the last 4
commands executed.
The next line above this displays break point and last error messages.

An error code is returned to MS-DOS?, with one of the following
meanings:
Error Code     Meaning
----------     -------
     0         No error
     1         VERF error
     2         MS or BF error
     3         Talker communication failure.

In MS-DOS? Batch files the error code can be checked with ERRORLEVEL.


6.2 Monitor  Commands

The following is a list of all commands available from PCbug11, with a
short description of their function. A more detailed description follows
in section 6.2.2.

6.2.1 PCbug11 Command Summary

ASM addr [mne|dir]            - Call symbolic macro line assembler, with
                              option to auto insert mnemonic or
                              directive
BAUD [rate]                   - Display/Set serial baud rate
BF addr1 [addr2] byte|word    - Block fill memory with byte or word
BL                            - Display breakpoints
BR [addr [macroname]]         - Display/Set break point
                              [with optional Command Macro execution]
CALL addr                     - Execute the subroutine at addr
CLRM                          - Clear all Command Macros
CLS                           - Clear main window
CONTROL [parameter]           - Display/Change PCbug11 system
                              parameters
DASM addr1 [addr2]            - Disassemble from addr1 [to addr2]
DB startaddr [endaddr]        - Display MCU Memory
DEBUG                         - Reserved word
DEFINE symbol value|address   - Define a symbol
DEFM macrnam|TRACE|AUTOSTART  - Define Command,Trace or Autostart
                              Macro
DELM macrnam|TRACE|AUTOSTART  - Delete Command,Trace or Autostart
                              Macro
DIR [mask]                    - Display Disk Directory
DOS [command]                 - Shell to DOS/Execute DOS command
EDITM macrnam                 - Edit a macro
EEPROM [startaddr [endaddr]]  - Display/Clear/Set EEPROM Address
                              Range(s)
EEPROM DELAY option           - Set EEPROM erase/write programming
                              time
EEPROM ERASE [option]         - Display/Change EEPROM Erase-before-
                              Write
EPROM [startaddr [endaddr]]   - Display/Clear/Set EPROM Address
                              Range(s)
EPROM DELAY option            - Set EPROM erase/write programming
                              time
FIND byte|word addr1 addr2    - Find all occurrences of byte or word
                              between addr1 & addr2
FIND mnemonic addr1 addr2     - Find all occurrences of mnemonic
                              between addr1 & addr2
G [addr]                      - Start User Code Execution
HELP                          - Display Help Information
KLE                           - Kill last error message
LOADM [filename] [macroname]  - Load Macro Definitions from Default/User
                              File
LOADS filename [loadaddr]     - Load S Record File into MCU Memory
LS symbol                     - Display symbols
LSTM [mname|TRACE|AUTOSTART]  - Display Macro Names/Definitions
 PCbug11 Command Summary (continued)


MD startaddr [endaddr]        - Display MCU Memory
MM addr                       - Modify memory from addr
MOVE addr1 addr2 addr3        - Move MCU Memory between addr1 &
                              addr2 to addr3
MS addr byte|word [byte|word] - Set MCU Memory Byte(s) or Word(s)
MSG [string]                  - Display Message in Main Window
NOBR [address]                - Remove all/specified Break Points
PAUSE [ms]                    - Wait for any Key Press/Delay Time
PRINT                         - Display PCbug11 version number
PROTECT [startaddr [endaddr]] - Display/Clear/Set Write Protected
                              Address Range(s)
QUIT [Y]                      - Terminate PCbug11 session [without
                              confirming]
RD [T]                        - Display/Trace MCU Registers
RESET [addr]                  - MCU Hardware Reset with Existing/New
                              Reset Vector.
RESTART [option]              - Restart PCbug11 with Same/New Option.
RM                            - Modify MCU Registers in window
RS register value             - Set value of MCU register
S                             - Stop User Code Execution
SHELL ["command" ;P]          - Shell to DOS/ Execute DOS command
SAVEM [filename]              - Save Macro Definitions in Default/User
                              File
T [addr]                      - Trace User Code
TERM [X1 Y1 X2 Y2]            - Simple windowed terminal emulator
TYPE filename                 - Display Disk file in Main Window
UNDEF symbol                  - Undefine a symbol
VER                           - Display version number
VERF ERASE addr1 [addr2]      - Verify that memory contains $FF
VERF SET addr1 addr2 value    - Verify that memory contains value
VERF filename [memaddr]       - Verify S record disk file against memory
WAIT [ms]                     - Wait for ms

Special Key operations:
CTRL B         - Send Break on COM channel
CTRL P         - Toggle MCU Memory Write Protect/RTS line
CTRL R         - Attempt to re-synchronise talker

6.2.1.1 EVM Compatible commands

These commands operate in a similar manner to the command of the same
name on the Motorola 68HC11 EVM systems.

ASM, BF, BR, G, HELP, MD, MM, NOBR, RD, RM

6.2.1.2 CDS8 Compatible commands

These commands operate in a similar manner to the command of the same
name on the Motorola CDS8 system.

ASM, BAUD, DB, DEFINE, G, HELP, LS, RD, RS, SHELL, T, UNDEF, VER, WAIT


6.2.2 PCbug11 Command Description

ASM addr [mne|dir]  - Call symbolic macro line assembler, with
                    option to auto insert mnemonic/directive

Provides single line assembly/disassembly in main window.
The assembler is a single pass version of ASMHC11 2.6 and thus supports
the same mnemonics and directives. Symbols can be defined within ASM
using the standard Motorola syntax. Alternatively, symbols from an
(equate) file may be loaded using the INCL operand. Note that mnemonics
must be preceded by at least one space following the '>' prompt,
otherwise they are treated as labels The same text editing features are
available as on the command line.
The following keys provide additional features:

up arrow       decrement prog counter by one.
down arrow     increment prog counter by one.
enter          move prog counter to next instruction boundary.
Esc       Exit ASM and return to command line.

In PCbug11 there is the ability to optionally specify on the command
line, a mnemonic or directive. If this is done, the ASM command
automatically inserts the mnemonic or directive, and immediately returns
to the command line. This allows mnemonic insertion or ASM directives to
be executed from within a macro, without any input from the user.

Usage:
ASM $100       Assemble from memory address $100
ASM $100 INCA  Insert INCA instruction at memory address $100

ASM Error messages
These are reported in the form of numbers the key to which is shown
below

Error no. Meaning

     1    Memory fault : Memory did not modify as expected
     200  Syntax : Illegal character in that context
     202  Syntax : Syntax error
     204  Syntax : Label required (for EQU or SET)
     212  Operand : Improper termination of operand field
     213  Operand : Illegal addressing mode for operand
     214  Address : Illegal forward reference
     223  Address : Invalid addressing mode for 68HC11
     234  Symbol : Redefined symbol
     235  Symbol : Undefined symbol
     238  Symbol : Undefined operation
     320  Symbol : Error table overflow
     321  Symbol : Symbol table overflow
     250  Data : Displacement too large (normally branch)
     251  Data : Value out of range
     252  Data : Address too large for forced direct
     255  Data : Division by zero
     
     501  File : File not found
BAUD [rate]    - Display/Set serial baud rate

Allows user to change the PC's serial baud rate. This command accesses
the PC's hardware directly, to allow a wider range of baud rates than
can be selected by the  MODE command. After execution, the actual baud
rate is displayed. This may be different to the requested baud rate.
Values in excess of 9600 are available - with a maximum of 38400 baud.

Note 1: To maintain Talker contact, the MCU's baud rate must first be
set up to the new value. This can either be done by changing the
appropriate talker code, or executing an MS command to dynamically
change the MCU's baud rate register.

Note 2: The default baud rate for bootstrap download is approximately
7812, and for talker communication it is 9600. These may be changed by
specifying a different baud rate when PCbug11 is started from the MS-
DOS? command line. This feature has been added to allow PCbug11 and all
talker codes to work without modification with different MCU crystal
frequencies. e.g. if the MCU crystal is 4MHz, then to start up an
MC68HC11A8 in bootstrap mode the command is: PCBUG11 -A 3906 This will
ensure that PCbug11 uses half the default values (i.e 3906=7812/2) for
both download and TALKER communication.

Note 3: Changing the baud rate will affect the minimum EEPROM
programming time, as the EEPROM programming algorithm used by PCbug11
relies on the serial data transfer time.

Usage:
BAUD           Display current Serial baud rate.
BAUD 19200     Change baud rate to 19200 baud.
BF addr1 [addr2] byte|word         - Set MCU Memory Byte(s) or Word(s)

This command forces an 8 bit or 16 bit value into MCU memory, starting
at address <addr1> and finishing at address <addr2>. If <addr2> is not
specified then only <addr1> itself is modified. If the starting address
is in an EEPROM block (as specified by the EEPROM command), then an
EEPROM algorithm will be used to store the value. This action is
completely transparent to the user. Block fill automatically verifies
the contents of memory filled.

Note: When setting memory to $00, ensure that the $00 is not specified
in the most significant byte of a 16 bit value, as this will be
interpreted as an 8 bit value and may result in incorrect addressing of
MCU memory.

Usage:
BF $1000 $AA        Set MCU memory address $1000 to a value of $AA
BF $C000 $CFFF $D3  Set MCU memory addresses $C000 to $CFFF to the
                    value $D3.
BF $00 $FF $FF00    Set MCU memory addresses $00 to $FF to values
                    $FF,$00,$FF,$00 alternately.

Related commands: DB,MD,MS


________________________________________________________________________


BL        - Display Breakpoints

This command displays the list of current breakpoints. The breakpoint is
displayed in hexadecimal format and followed by a macro name if one is
defined.

Usage:
BL        Display the hexadecimal address of all user defined
          breakpoints. Any command macro tagged to the
          breakpoint is displayed in brackets () after the breakpoint

Related commands: BR,NOBR
BR [addr [macroname]]    - Display/Set break points [with optional
                         Command Macro execution]

This command installs an entry in a breakpoint table, to permit
suspension of user code execution initiated by the G command.

Breakpoints are set in MCU memory only when the user starts execution of
code with the G command. Before control is passed to user code, a SWI
instruction is placed at every breakpoint address specified in the
breakpoint table. PCbug11 can handle user placed SWIs, with some
overhead, provided the user's SWI vector is downloaded from an S record
file using the LOADS command, and there are no breakpoints at the user
SWI instructions. Note that when PCbug11 is first started, it reads the
MCU's SWI vector and treats it as the user's.

It is possible to have a macro run on reaching a particular breakpoint.
If the macro is not defined then PCbug11 will behave as if no macro had
been specified. If when listing breakpoints the macro selected is not
defined then the name of the macro is displayed preceded by ?. If no
macro has been defined for the breakpoint then the macro is displayed as
(-).

Usage:
BR                  Display the hexadecimal address of all user defined
                    breakpoints. Any command macro tagged to the
                    breakpoint is displayed in brackets () after the
                    breakpoint address.
BR $C0F1 $C045      Set breakpoints at MCU addresses $C0F1 and $C045.
BR $C023 DISPREG    Set breakpoint at MCU address $C023 and execute        
     macro DISPREG  when the breakpoint is reached.

Related commands: BL,NOBR

________________________________________________________________________

CALL addr - Execute the subroutine at addr

This command causes the monitor to execute the MCU code located at
<addr>. The MCU code must be terminated by an RTS instruction, otherwise
monitor operation may be affected. The command has the same affect as
the MCU instruction JSR <addr>. The current state of the monitor is
unaffected.

Related command:  G
CLRM           - Clear all Command, Trace and Autostart
               Macros

This command removes all macro names and definitions from the current
library, including the TRACE macro. It does not affect libraries stored
on disc with the SAVEM command.

Related commands: DEFM,DELM,EDITM,LSTM,SAVEM,LOADM


________________________________________________________________________


CLS       - Clear the main window

This command clears the main (blue) window on the screen. It also clears
the last error/breakpoint messages if they are present.

Related commands: KLE

________________________________________________________________________


CONTROL [parameter]      - Display/Change PCbug11 system parameters

If no parameters are specified, then this command displays certain
parameters used by PCbug11, which can be modified by the user. The
available parameters and their functions are as follows:

CONTROL HARDWARE         Access serial COM port directly through
                         hardware
CONTROL BIOS             Access serial COM port through BIOS calls
CONTROL RTS              Control RTS level directly.
CONTROL PROTECT          Use RTS to provide memory write protect
                         function
CONTROL TIMEOUT value    Specify value of serial COM timeout during
                         input
CONTROL COM1|COM2        Specify which COM port to use
CONTROL ERRMSG 0|1       Disable or enable display of memory error
                         messages
CONTROL LAST             Toggle last error message window on/off
                         (default on)

On startup, PCbug11 determines whether hardware access is possible, and
if so, it uses this mode, and enables direct control of the RTS,
otherwise it uses BIOS calls to the COM port, and enables memory write
protect control. COM1 is used by default, but can be changed by
specifying port=2 on the command line when starting PCbug11. e.g.
PCBUG11 -A port=2
(See DEFM,SAVEM,LOADM for details of macro libraries)



DASM addr1 [addr2]       - Disassemble from addr1 [to addr2]

Disassembles MCU memory from address <addr1> for approximately 15 bytes,
or to address <addr2> if specified. Disassembled code is displayed in
main window. Display halts when the screen is filled. Press any key,
except Esc, to continue disassembly for up to 15 bytes, or until address
<addr2> is exceeded. Pressing Esc key immediately terminates
disassembly. If only addr1 is specified, and it is the same as the
current program counter, then disassembly stops after only one line is
displayed.
This provides a convenient method of tracing program code when using a
Trace macro, which should contain the command: DASM *. Note that DASM
will display a symbol in place of its value if one exists.

Usage:
DASM $B3                 Disassembles MCU addresses $B3 to $C2
DASM $BF00 $BFFF         Disassembles MCU addresses $BF00 to
                         $BFFF

Related command: ASM,LS


________________________________________________________________________


DB startaddr [endaddr]        - Display MCU memory

This command displays the contents of memory starting at <startaddr> and
ending at <endaddr>. If <endaddr> is not specified then the contents of
<startaddr> and the following 15 locations are displayed.

Usage:
DB $1000       Display MCU memory addresses from $1000 to $100F
DB $C000 $CFFF Display MCU memory addresses from $C000 to $CFFF

Related commands: BF,MS,MD


________________________________________________________________________



DEBUG          - Reserved word

This command is reserved by PCbug11 for development use. Macros cannot
be labelled using this name.
DEFINE symbol value|address        - Define a symbol

This command allows the user to explicitly define the value of a symbol.
Each symbol has a name and a value.

The symbol name may consist of lower and/or upper case letters. The case
of each letter is sensitive. That is abc does not equal ABC. In use
symbols are simply replaced by their value in commands and the value is
replaced by the symbol name in a disassembly listing.

Usage:
DEFINE PORTA $1000       Define symbol PORTA=$1000
DEFINE mask1 45          Define mask1=45 ($2D)

Related commands: LS,UNDEF


DEFM macroname|TRACE|AUTOSTART]    - Define Command, Trace or
                    Autostart Macro

This command allows users to create command sequences (macros), which
can be executed simply by typing the name of the macro. Up to 10
parameters can be passed to command macros. Within the macro, the
required parameter is specified by the operator @N, where N is a single
digit number between 0-9 inclusive. The syntax and use of pass
parameters is the same as found in Motorola's assemblers. <macroname>
can be any sequence of alphanumeric characters except reserved command
names. Macros can be nested up to 5 levels. More than one macro is
allowed at a time and these are held in an area known as the macro
library. Macro libraries can be saved on disk and loaded again when
required.

The reserved parameter name TRACE allows the user to define a macro
which is executed on completion of every T (trace) command. See T for
further details.

The reserved parameter name AUTOSTART allows the user to define a macro
which is executed automatically on startup of PCbug11. To correctly use
the AUTOSTART feature, the macro library containing the macro AUTOSTART
must be saved using the SAVEM command. Then, from MS-DOS?, the macro
library name must be specified as the last parameter on the command
line.
e.g. From PCbug11:
     DEFM AUTOSTART
     (type in macro definitions in main window. then press Esc key)
     SAVEM STARTUP
     QUIT      (Quits PCbug11)

Then from PC command line:
     PCBUG11 -A STARTUP
     (STARTUP library is loaded and AUTOSTART executed, if it exists)

The main window is used to type in the macro definition. Other macro
names may be included in the definition. To terminate the definition,
press the ENTER/RETURN key on a blank line. Once defined, the macro
cannot be edited within PCbug11. It may be edited using a standard text
editor once the file has been saved, since PCbug11 saves macros in a
special text format (see LOADM). Macros can also be defined by the user
using a text editor if the special format is used.

If the specified macro name already exists, then the existing macro is
overwritten by the new definition.

Usage:
DEFM CONFIG    Create macro called CONFIG
DEFM TRACE     Create macro which is executed after T command
DEFM AUTOSTART Create macro which can be executed automatically on
               startup of PCbug11.

Related commands:CLRM,DELM,EDITM,LOADM,LSTM,SAVEM
DELM macroname|TRACE     - Delete Command or Trace Macro

As all macros must be accommodated within the free memory space
available on the PC, this command allows the user to free up space for
other definitions.

Usage:
DELM CONFIG    Remove CONFIG macro name and definition
DELM TRACE     Remove macro name and definition used by T (trace)
               command

Related commands: DEFM,CLRM,SAVEM,LOADM,LSTM


________________________________________________________________________


DIR [mask]          - Display disk directory

This command causes the directory/contents specified by the mask to be
displayed. Standard DOS masks apply.

Usage:
DIR            Display contents of current directory
DIR *.MCR      Display all the files in the current directory with the
               extension .MCR (macros)
DIR \          Display all files in the root directory
DIR ..\*.PAS   Display all the files in the directory above the current
               one with the extension .PAS

Related command: TYPE


________________________________________________________________________


DOS [command]       - Shell to DOS/Execute DOS command

If no command parameter specified, then DOS causes PCbug11 to shell to
MS-DOS. To return to PCbug11, type EXIT at the DOS prompt. If a command
is specified, then PCbug11 will execute the command, and return to
PCbug11. Prior to returning, the program PCBUGRTN.EXE is executed (this
program must be stored in the same directory as PCBUG11.EXE). This
program can be user defined if required. The supplied version simply
displays a message and waits for any key press.

Usage:
DOS COPY *.TXT a:/V Execute COPY command and return to PCbug11
EDITM macrnam       - Edit a macro

This command allows the user to edit macros once they are defined/loaded
into PCbug11. It is a full screen editor type and uses various function
keys to edit the macros.

On executing the command PCbug11 displays the first 10 lines of the
macro or less if there are fewer lines in a new window. Each line is
preceded by a digit 0 to 9.

The editor obeys the following commands:

<alphanumeric>  Insert key pressed into the current macro text.
               Character will replace current one if insert is off. If
               insert is on the character will be inserted before
               current character.

<del>          The delete key will delete the character current under
               the cursor.

<ins>          Toggle insert function on/off. Default is on.

<enter>        Insert a new line in the macro.

<pgdn>         The page down key displays the 10 lines following the
               current cursor line.

<pgup>         The page up key displays the 10 lines before the current
               cursor line.

<esc>          The escape key aborts the edit. The macro is not saved.

<F3 key>       Complete edit and save alterations in macro library. Note
               ALT-Q and ALT-E will also perform this function.

Users move from line to line by pressing the arrow keys to move in the
direction indicated. Lines which do not contain any characters after the
edit are removed automatically. There is no direct command to delete a
line. If the first characters in the line are spaces then they are
removed

If the macro does not exist it is created as a null macro. If a null
macro is edited, only the first line is displayed (as a blank line).

Usage:
EDITM macro1   Edit the macro macro1.

Related commands: CLRM,DEFM,DELM,LOADM,LSTM,SAVEM
1/EEPROM [startaddr [endaddr]]     - Display/Clear/Set EEPROM
                                   Address Range(s)

This command allows the user to transparently perform memory modify
operations on the 68HC11 internal EEPROM, including the CONFIG register.
Once an EEPROM address range is specified, all memory write operations
within that range will be handled by the appropriate EEPROM programming
algorithm. The command will not accept an address range which includes
the PPROG register.
Instructions affected: ASM, BR, LOADS, MM,MOVE, MS, NOBR, T

Usage:
EEPROM              Display memory address range to use EEPROM
                    algorithm.
EEPROM 0            Clear all EEPROM memory address ranges.
EEPROM $103F        Enable a write to address $103F to use EEPROM
                    algorithm.
EEPROM $B600 $B6FF  Enable writes within range $B600-$B6FF to use
                    EEPROM algorithm
------------------------------------------------------------------------
2/ EEPROM DELAY mS  - Set EEPROM erase/write programming time

This command allows the user to specify the EEPROM Erase and Write
programming time, within the range Min_delay to 255mS. The value of
Min_delay depends on the serial baud rate, since the EEPROM programming
algorithm used by PCbug11 relies on serial data transfer time. With a
9600 baud serial rate, the minimum delay time is 12mS. Note EPROM DELAY
has the same effect as this command, care should be taken when using
both commands.

Usage:
EEPROM DELAY 20     Sets the Erase and Write time delay to 20mS
EEPROM DELAY        Display the delay time in use
------------------------------------------------------------------------
3/ EEPROM ERASE [option] [addr]    - Display/Change EEPROM Erase before    
                                   Write function or bulk erase EEPROM.

This command allows the user to enable or disable EEPROM byte erasure
before byte programming. The default state is Erase-before-Write
Enabled. Another option of this command allows bulk erasure of the
EEPROM array at $B600-$B7FF, or at the address specified by <addr>.

Usage:
EEPROM ERASE             Display EEPROM Erase-before-Write state
EEPROM ERASE DISABLE     Disable EEPROM Erase-before-Write
EEPROM ERASE ENABLE      Enable EEPROM Erase-before-Write
EEPROM ERASE BULK        Bulk erase EEPROM array starting at $B600
EEPROM ERASE BULK $E000  Bulk erase EEPROM array starting at $E000

Note: After executing EEPROM ERASE BULK, Erase-before-Write is
automatically disabled. This allows the fastest download of S records to
EEPROM using the LOADS command. The bulk erase time defaults to
approximately 200mS. It is recommended that Erase-before-Write be
enabled before executing commands which may modify non-erased EEPROM.
e.g. ASM,BR,T
1/EPROM [startaddr [endaddr]] - Display/Clear/Set EEPROM Address
                              Range(s)

This command allows the user to transparently perform memory modify
operations on the 68HC711 internal EPROM. Once an EPROM address range is
specified, all memory write operations within that range will be handled
by the EPROM programming algorithm. The command will not accept an
address range which includes EPROG/PPROG.

Note that in general the EPROM command will only operate if an external
programming voltage is applied. IN GENERAL THE PROGRAMMING VOLTAGE
SHOULD NOT BE PRESENT BEFORE Vcc IS PRESENT. ALSO THE PROGRAMMING
VOLTAGE SHOULD NOT BE PRESENT AFTER Vcc IS REMOVED. Also the programming
voltage is generally applied to the XIRQ pin and so an XIRQ talker may
not be used. PLEASE CONSULT THE HC11 DATA/INFORMATION SHEET BEFORE USING
PCbug11 WITH EPROM PROGRAMMING.

Instructions affected: ASM, LOADS, MOVE, MS, NOBR, T

Usage:
EPROM               Display memory address range to use EPROM
                    algorithm.
EPROM 0             Clear all EPROM memory address ranges.
EPROM $D000 $FFFF   Enable writes within range $D000-$FFFF to use
                    EPROM algorithm
------------------------------------------------------------------------
2/ EPROM DELAY mS   - Set EPROM erase/write programming time

This command allows the user to specify the EPROM Write programming
time, within the range Min_delay to 255mS. The value of Min_delay
depends on the serial baud rate, since the EPROM programming algorithm
used by PCbug11 relies on serial data transfer time. With a 9600 baud
serial rate, the minimum delay time is 12mS. Note EEPROM DELAY has the
same effect as this command, care should be taken when using both
commands.

Usage:
EEPROM DELAY 20     Sets the Erase and Write time delay to 20mS
EEPROM DELAY        Display the delay time in use
1/ FIND byte|word addr1 addr2 - Find a bit pattern in MCU memory

<word> is a 2 byte value.
This command will read and search through the memory address range
specified by the last 2 parameters in the command line. The addresses of
all occurrences of the 1st parameter (byte or word) are displayed in the
main window. The syntax above is the simplest form, where a byte
parameter is simply a value in range $00-$FF and a word is in the range
$100-$FFFF. A maximum pattern of 4 consecutive bytes may be searched
for. If the pattern contains leading $00s then the 1st parameter after
FIND must be the byte count of the pattern to search for.

Usage:
FIND $AA $E000 $E3FF          Find and display all occurrences of $AA in
                              address range $E000 to $E3FF inclusive.
FIND $AA55 $B600 $B7FF        Find and display all occurrences of $AA55
                              in 68HC11A1 EEPROM (Addresses $B600 to
                              $B7FF)
FIND 2 $0012 $F800 $FFFF      Find and display all occurrences of $0012
                              iN address range $F800 to $FFFF.
FIND 3 $00 $1234 $C000 $DFFF  Find and display all occurrences of
                              $001234 in address range $C000 to $DFFF.
------------------------------------------------------------------------
2/ FIND mnemonic addr1 addr2  - Find a mnemonic in MCU memory

This syntax eases the search for specific assembler code. The wild card
operator ? may be used in the mnemonic operand to force a search for the
opcode only. If the mnemonic addressing mode is not an indexed one, then
its operand must be immediately preceded, without a space, by one of the
following 3 symbols as appropriate: # (immediate); < (direct); >
(extended)

Usage:
FIND LDAA >$1234 $E000 $E200  Find and display all occurrences of
                              LDAA >$1234 in address range
                              $E000 to $E200.
FIND LDAB $34,X $C230 $C560   Find and display all occurrences of
                              LDAB $34,X in address range
                              $C230 to $C560
FIND LDX #? $F000 $F2FF       Find and display all occurrences of
                              immediate load X opcode in range
                              $F000 $F2FF

Note that a maximum of 4 characters can be searched for.
G [addr]                 - Start user code execution

This command causes the 68HC11 to begin executing the user code. If
<addr> is not specified then execution will commence at the current
program counter. If <addr> is specified then execution will commence at
that address.

Usage:
G              Commence program execution at current program
               counter
G $B600        Commence program execution at $B600

Related command: S


________________________________________________________________________


HELP [command]           - Display help information

This command displays help information in a window which is displayed on
top of the main window. If no <command> is specified then a general help
screen is displayed. The user may scroll through the help window by
using the up and down arrows and page up and page down keys. The user is
unable to alter the contents of the help information. The help window is
cleared by pressing the ESC key.

The help information is stored in a text file called PCBUG11.HLP. The
default help option is help MENU which displays the help available.

Usage:
HELP      Display general help menu ( same as HELP MENU)
HELP RS   Display help for RS command

________________________________________________________________________


KLE       - Kill last error message

This command causes the last error/break point window to be cleared.

Usage:
KLE

Related commands: CLS
LOADM [filename] [macroname]  - Load Macro Definitions from
                              Default/User File and optionally
                              immediately execute macro.

This command loads a library of previously defined macros stored on disc
with the SAVEM command or created by the user using a text editor. The
format of the file is checked against the macro rules and is not loaded
if the format is not valid - see below. The newly loaded library is
added to any existing library. If <macroname> is specified, and exists
in the newly loaded library, it is immediately executed after loading.
The default extension for loading macro libraries is .MCR.

Usage:
LOADM          Loads macro library from default file
               PCBUG11.MCR    
LOADM USERLIB  Loads macro library from files USERLIB.MCR
LOADM A A      Loads macro library from file A.MCR and
               immediately executes the macro named A.

Related commands: CLRM,DEFM,DELM,EDITM,LSTM,SAVEM


Valid text format for macro files

DEFM macroname
BEGIN
     macro_instructions
END

macroname is the name of the macro being defined
macro_instructions are the PCbug11 instructions which the macro contains

Comments are allowed and are enclosed in { } brackets.

Note that comments are stripped out by PCbug11 when loaded. If a library
is saved any comments present when the macros are loaded are lost.

Parameters are passed into macros by the @ symbol. That is @0 will be
replaced by the first parameter when calling the macro, @1 will be the
second etc.
LOADS filename [loadaddr]     - Load S Record File into MCU
                              Memory, at optional new start address.

The <filename> parameter in the command is of the form <filename.ext>
If no extension is specified then .S19 is assumed by the monitor. The
default path is the current working directory, but the user may specify
any path and/or drive letter in accordance with the rules of MS-DOS?.
Only S1 records are loaded. All other S record types are ignored, as are
blank lines. Invalid format lines may generate an error message.

The S record data is normally loaded into MCU memory at the addresses
specified in the S1 record load address field. However, the S record
data can be relocated, during loading, to an alternative starting
address by including the required address on the command line. During
loading, PCbug11 traps certain mode-dependent user vectors, to give the
monitor priority - these vectors are:

In Bootstrap mode:  SWI   - Used for breakpoint and trace processing.
In External mode :  RESET - Used to start the monitor after a hardware
                              reset.
                    SWI   - Used for breakpoint and trace processing.
                    XIRQ  - Used by the external ACIA to provide highest
                              priority host communication.

Note that all these vectors are available to the user. The only
difference is that there is a slight speed overhead associated with
their execution. However, if no user breakpoints are defined, then user
SWI instructions will be executed in real time, with no monitor
overhead. Refer to the source listings of the appropriate talker code to
determine the effects of user RESET and XIRQ on your software.


________________________________________________________________________


LS symbol      - Display Macro Names/Definitions

The currently defined symbols are listed by this command. The name
symbol may include the * terminator which indicates a wild card
character. This may appear only at the end of the symbol name The wild
card indicates any combination of letters is possible and is used to
display symbols of similar name.

Usage:
LS *           Display all symbols
LS one         Display value of symbol one
LS PORT*       Display all symbols which commence with the letters PORT.

LSTM [macroname|TRACE]   - Display Macro Names/Definitions

This command displays either all macro names in the current library, or
the expanded definition of a specified macro. Where macro names are used
within a macro definition, the display on the screen is indented at each
nested level.

Usage:
LSTM           Display the names of all macros in the current library
LSTM CONFIG    Display the definition of macro CONFIG
LSTM TRACE     Display the definition of the macro used after execution
               of the T (trace) command.

Related commands: CLRM,DEFM,DELM,EDITM,LOADM,SAVEM

________________________________________________________________________


MD startaddr [endaddr]   - Display MCU memory

This command displays the contents of memory starting at <startaddr> and
ending at <endaddr>. If <endaddr> is not specified then the contents of
<startaddr> and the following 15 locations are displayed.

Usage:
MD $1000       Display MCU memory addresses from $1000 to $100F
MD $C000 $CFFF Display MCU memory addresses from $C000 to $CFFF

Related commands: BF,DB,MS


________________________________________________________________________


MM addr             - Modify memory from addr

This command modifies memory from the address specified in the command
line. The contents of each memory location selected are displayed and
the user may then alter this by entering a value or select the next
location by pressing return. Memory may also be stepped through by using
the up and down arrow keys. The memory modify is completed by pressing
the <ESC> key. If the memory area has been predefined as EEPROM or EPROM
then the modify will be transparent to the user into these areas. An '='
on the memory line will cause the current location to be modified and
then stay at the same address. The command is also terminated by having
a '.' on the line. Note that only hex digits are accepted and no digits
will be accepted on a line following a '.' .

Usage:
MM $100        Modify from address $100.

Related commands: MS
MOVE addr1 addr2 addr3   - Move memory between addr1 and addr2 to addr3

This command performs a memory move. The contents of the source memory
locations are unaltered. The destination address is indicated by addr3
and will be filled with the contents of addr1 to addr2. If the memory
area has been predefined as EEPROM or EPROM then the move will be
transparent to the user into these areas.

Usage:
MOVE $100 $150 $200      Move $50 bytes from $100 to $200


________________________________________________________________________


MS addr byte|word [byte|word] - Set MCU Memory Byte(s) or Word(s)

This command forces 8 bit or 16 bit values into MCU memory, starting at
address <addr>. A maximum of 9 values (8 or 16 bit) can be specified
after parameter <addr>. Each value is written to consecutive addresses
starting at <addr>. If the starting address is in an EEPROM block (as
specified by the EEPROM command), then an EEPROM algorithm will be used
to store the value. This action is completely transparent to the user.

Note: When setting memory to $00, ensure that the $00 is not specified
in the most significant byte of a 16 bit value, as this will be
interpreted as an 8 bit value and may result in incorrect addressing of
MCU memory.

Usage:
MS $1000 $AA        Set MCU memory address $1000 to a value of $AA
MS $C000 $1234 $56  Set MCU memory addresses $C000,$C001,$C002 to
                    the values $12,$34,$56 respectively.
MS $50 $55AA $FF00  Set MCU memory addresses $50,$51,$52,$53 to the
                    values $55,$AA,$FF,$00 respectively.

Related commands: BF,MD


________________________________________________________________________


MSG [string]   - Display Message in Main Window

Prints string to screen, without command line trace.
The RTS line (write protect control) can be toggled if <string> is ^P.
NOBR [address] - Remove all/specified Break Points

If no parameter is specified after the command, then all Breakpoints are
removed from the breakpoint table, and the SWI vector is restored to its
previous state. This implies that, if a user SWI vector had been
previously installed by the LOADS command, or was detected when PCbug11
was first started, then user SWIs will run in real time without
intervention by PCbug11. If a parameter is specified after the command,
then the breakpoint at that address is removed.

Usage:
NOBR           Remove all breakpoints, and restore previous SWI
               vector.
NOBR $E034     Remove breakpoint at address $E034.

Related Commands: BR


________________________________________________________________________



PAUSE [mS]          - Wait for any Key Press/Delay Time

The PAUSE command is useful in macros, where macro execution is halted
until either a key is pressed, or the specified time has elapsed.
Continuation from a PAUSE command is also achieved when the byte value
$4B is received on the PC serial port. This allows the target MCU to
control the execution of PCbug11 macro commands.

Usage:
PAUSE          Suspend command execution until any key is pressed,
               or the value $4B is received on the PC serial port.
PAUSE 1000     Suspend command execution for 1000mS.

Related commands: WAIT


________________________________________________________________________


PRINT          - Display PCbug11 revision number

This command displays the PCbug11 start up message. This shows the
Motorola copyright message and the revision number in use.

Usage:
PRINT     Display revision number

Related commands:VER

PROTECT [startaddr [endaddr]]      - Display/Clear/Set Write Protected
                                   Address Range(s)

This command allows the user to inhibit PCbug11 from writing to any MCU
memory location, either internal or external. Once the command is
executed with an address or range of addresses, then PCbug11 will not
permit any memory modify operation from taking place on those locations.
If this is attempted, then an error message will appear to the right of
the command line, indicating that the command has been terminated
without modifying the memory location. Note that this command does not
inhibit the user's own MCU code from writing to memory addresses.
Instructions affected: ASM, BR, LOADS, MOVE, MS, NOBR, T

Usage:
PROTECT             Displays all 'write protected' memory address
                    ranges.
PROTECT 0           Clears all 'write protected' memory address ranges.
PROTECT $102B       Prevents PCbug11 from writing to BAUD register.
PROTECT $FFC0 $FFFF Prevents PCbug11 from changing any 68HC11
                    vectors.

________________________________________________________________________


QUIT [Y]       - Terminate PCbug11 session

This command causes PCbug11 to terminate. If <Y> is not specified then a
further prompt is required before the session is ended. No check is made
to see if breakpoints have been cleared or macros saved before the
command is carried out.

Usage:
QUIT      Terminate session (PCbug11 will confirm this with user)
QUIT Y    Terminate session without confirmation


________________________________________________________________________


RD [T]    - Display/Trace MCU Registers

Without the option <T>, this command displays the current value of the
MCU's registers in the register window. With the option T, the registers
are displayed in the main window, allowing a continuous register trace
to be seen. The command can be executed while the MCU is executing user
code. By careful use of both options, the MCU state at a particular
point can be permanently frozen on screen, using the RD command alone,
whilst continuously displaying the newest state using the RD T option.

Related commands: RM,RS
RESET [addr]        - MCU Hardware Reset with Existing/New Reset Vector.

This command causes the MCU to generate a hardware reset and optionally
start execution of user code at <addr> or at the address specified by a
previous RESET command. Once the reset occurs, the default
implementation of PCbug11 causes the talker code to re-initialised, and
then the MCU either idles, if no user specified address was given in the
command line, or the talker code jumps to the address specified by
<addr> on the command line. Note that once <addr> has been specified, it
is maintained in the talker code until replaced by another value.
Refer to the appropriate talker code source listing for details.

Note:
To simulate an external hardware reset, the RESET command forces the MCU
to generate an internal reset which also causes the external RESET pin
to go low. To produce the internal reset, the Clock Monitor Fail
detector is used. PCbug11 implements this by downloading and executing
the following code in a reserved area of RAM:
     STY cme_jmp    Clock monitor fail jump address
     STAA OPTION,X  OPTION=$39
     STAB TEST1,X   TEST1=$3E
     STOP
     JMP user_start <- in case STOP doesn't generate CME reset!

Where:
     Y=user reset address
     X=$1000   Default I/O register base address for M68HC11
     ACCA=$08  Enables the clock monitor in the OPTION reg.

The values passed to ACCB, CCR and Y depend on the MCU type & operating
mode.

In Bootstrap mode: If MCU is an 'A8, ACCB=0 to clear the DISR bit in
TEST1 reg. For all other devices, ACCB=4 to force the clock monitor
reset by setting the FCM bit in TEST1 reg. For all devices, CCR=$40 to
enable the STOP instruction and I bit interrupts, and disable XIRQ to
allow execution of the instruction after STOP if all else fails! The
user reset address is $0000.

In External mode:  For all devices, ACCB=$0, since TEST1 is not
accessible in normal modes. CCR=$10 to enable STOP and XIRQ, and disable
I bit interrupts. The user reset address is defined by the user in the
appropriate .MAP file

Note also that the above reset code forces the value in the Clock
Monitor Fail vector, before starting user code execution. This means
that the user must dynamically assign this vector in software before
using the feature. The effect of this internal reset is identical to an
external hardware reset, except that the COP Clock Monitor fail vector
is taken instead of the RESET vector - provided the rising edge of the
reset output signal is not delayed by external capacitance. Refer to the
M68HC11 data book and User manual for details.
RESTART [option]    - Restart PCbug11 with Same/New Option.

This command performs a complete restart of the monitor, and is
equivalent to typing the MS-DOS? command: PCBUG11 option. The only
difference is that command macros are retained. Assembler macros and
symbols are lost.

Usage:
RESTART        Restart monitor with option specified when PCbug11
               was first executed
RESTART -XE    Restart monitor with -XE option. Equivalent to
               typing command:PCBUG11 -XE

Note: RESTART is useful when complete communication failure occurs, or
when the MCU is given an external hardware reset in bootstrap mode.


________________________________________________________________________


RM   - Modify MCU Registers in window

This command allows the MCU registers to be modified in the register
window using the normal keyboard editing keys. Each register is fielded
in its own section of the window. To move within and between fields, the
following keys are used:

Up arrow       -  Move back one register field
Down arrow     -  Move forward one register field
Left arrow     -  Move cursor backwards in current field
Right arrow    -  Move cursor forward in current field
Ins            -  Insert at current cursor position
Del            -  Delete at current cursor position
Return         -  Quit register edit and update all MCU registers
Esc            -  Quit register edit without changing MCU registers

Note: All fields, except SXHINZVC can be edited in decimal, binary or
hex format. The SXHINZVC field is in binary format only. After quitting
the edit the RD command is automatically run to confirm any register
changes.

Related commands: RD,RS


________________________________________________________________________


RS register value   - Set value of MCU register

This command allows the user to force the value of any MCU register.
Only one register at a time may be set. The register window is also
updated.
Valid options for <register> are: PC, ACCA, ACCB, X, Y, CCR, SP

Usage:
RS ACCA $61    Set MCU accumulator A to value $61
Related commands: RD,RM
S         - Stop user code execution

This command causes the 68HC11 to stop executing the user code.

Usage:
S         Stop program execution

Related command: G


________________________________________________________________________


SHELL ["command" ;P]     - Shell to DOS/Execute DOS command

If no command parameter specified, then SHELL causes PCbug11 to shell to
MS-DOS?. To return to PCbug11, type EXIT at the DOS prompt. If a command
is specified, then PCbug11 will execute the command, and return to
PCbug11. Prior to returning, the program PCBUGRTN.EXE is executed (this
program must be stored in the same directory as PCBUG11.EXE). This
program can be user defined if required. The supplied version simply
displays a message and waits for any key press. If the ;P option is
specified then the command is executed and immediately returns to
PCbug11 without running PCBUGRTN.

Usage:
SHELL "COPY *.TXT a:/V"  Execute COPY command and return to PCbug11


________________________________________________________________________


SAVEM [filename]    - Save Macro Definitions in Default/User File

This command saves on disc, the library of macros created by the DEFM
command. Macros are stored on a disc file with extension .MCR. These
files are normal text files and can be edited with standard text
editors. However, there is a special format used in the macro files
which the user must obey at all times if the macros are to be
successfully loaded in to PCbug11 again (see LOADM). If the file name is
omitted from the command, then the default name of PCBUG11 is used.

Note : Users should take care when saving a library to the same file
that the library was loaded from. If any comments existed in the
original library then they will be lost as PCbug11 strips out comments
when loading macros.

Usage:
SAVEM USERLIB  Save macro library in file USERLIB.MCR
SAVEM          Save macro library in default file PCBUG11.MCR
               (Equivalent to: SAVEM PCBUG11)

Related commands: CLRM,DEFM,DELM,EDITM,LOADM,LSTM,SAVEM

T [addr]  - Trace User Code

This command single step traces program code from the address specified
by the PC value, or addr, to the next logical address. Executing the
command causes a SWI to be placed at the next executable address(es). If
a command macro called TRACE has been defined, it is executed on
completion of the T command.

A useful Trace macro is: RD
                         DASM *

If the next executable instruction involves a branch to the current
address, the trace is disabled, to allow the instruction to execute.
However, PCbug11 will still display the TRACE state. Since the Talker is
interrupt driven, this does not cause any hang-up of the monitor, and
all PCbug11 commands are still available.


________________________________________________________________________


TERM [X1 Y1 X2 Y2]  - Simple windowed terminal emulator

With no options specified, this command starts a simple terminal
emulator using the currently defined terminal window. Initially this is
the entire screen area.
Optional values <X1>,<Y1>,<X2> and <Y2> redefine the window in which the
terminal emulator operates. Note that if used, all values must be
specified - their meanings are as follows:
     <X1> - Left column
     <Y1> - Top  row
     <X2> - Right column
     <Y2> - Bottom row

The values need to be specified only on the first use of the TERM
command - they remain in force until replaced by another set of values.
To quit the terminal emulator, press the Esc key.


________________________________________________________________________


TYPE [filename]          - Display contents of filename

This command causes the contents of the file filename to be displayed.
Standard DOS path names apply.

Usage:
TYPE RUNTIME.MCR    Display contents file RUNTIME.MCR in current
                    directory
TYPE \TEMP.BIT      Display file TEMP.BIT in root directory
TYPE ..\LIST.PAS    Display the file LIST.PAS in the directory above the
                    current one

Related command: DIR

UNDEF symbol        - Undefine a symbol

Remove symbol from the symbol table list. The * wildcard character may
be used. This character can only be used at the end of a symbol name and
indicates a random number of characters. The symbol * can be used on its
own and indicates ALL symbols - use with care!

Usage:
UNDEF one      Clear the symbol one
UNDEF PORT*    Clear all macros whose names begin with the letters PORT
UNDEF *        Clear all macros

________________________________________________________________________


VER                 - Display PCbug11 revision number

This command displays the PCbug11 start up message. This shows the
Motorola copyright message and the revision number in use.

Usage:
VER            Display revision number

Related commands: PRINT

________________________________________________________________________


VERF ERASE addr1 [addr2] - Verify that memory contains $FF

This command checks that the memory area specified is erased. That is
contains $FF. If addr2 is not specified then the byte at addr1 is
checked. If addr2 is specified then the block of memory between addr1
and addr2 is checked. If the memory does not match, then the memory
locations which are not erased are displayed along with the value it
contains.

Usage:
VERF ERASE $100          Check address addr1 is erased
VERF ERASE $E000 $FFFF   Check address block from $E000 to $FFFF is
                         erased
VERF SET addr1 addr2 value    - Verify that memory contains value

This command checks the contents of memory from addr1 to addr2 and
verifies that each byte is equal to value. If the location is not equal
to value then the memory value is displayed. Value is a single byte
value

Usage:
VERF SET $100 $1FF $35   Check that the block from $100 to $1FF contains
                         $35.


________________________________________________________________________



VERF filename [loadaddr] - Verify S Record File against memory.

The default extension of <filename> is .S19. The default path is the
current working directory, but the user may specify any path and/or
drive letter in accordance with the rules of MS-DOS?. Only S1 records
are verified. All other S record types are ignored, as are blank lines.
Invalid format lines may generate an error message.

The S record data is normally compared with MCU memory at the addresses
specified in the S1 record load address field. However, the S record
data can be compared to an alternative starting address by including the
required address on the command line as <loadaddr>.


Related command: LOADS


________________________________________________________________________


WAIT[ms]       - Wait for ms

The WAIT command is useful in macros, where macro execution is halted
until either a key is pressed, or the specified time has elapsed.
Continuation from a WAIT command is also achieved when the byte value
$4B is received on the PC serial port. This allows the target MCU to
control the execution of PCbug11 macro commands.

Usage:
WAIT      Suspend command execution until any key is pressed,
          or the value $4B is received on the PC serial port.
WAIT 1000 Suspend command execution for 1000mS.

Related commands:PAUSE
7 Advanced Topics

7.1 Macros

A useful feature within PCbug11 is being able to execute common command
sequences by typing just a single instruction. This feature is
implemented using macros.

Macros may be defined by the user either in PCbug11 or externally using
a text editor. It is possible to define more than one macro while using
PCbug11 and the area where the macros are held is called the macro
library.

Macros have two main elements - names and definitions. Every macro is
known by a name. This name can be any sequence of letters up to 80
characters long except for reserved commands within PCbug11. The macro
is run by typing its name in the same way as for other PCbug11 commands.

The macro definition consists of the commands which are to be carried
out by the macro. The commands are executed in the order in which they
are defined.

The total space within PCbug11 allowed for the macro library is limited
only by the size of the memory on the PC. This should be more than
enough for most applications. There is no limit on the maximum number of
macros allowable as long as the maximum memory limit is not exceeded. If
a macro is defined which has the same name as a macro which existed
previously then the macro which existed is automatically deleted,
although PCbug11 does warn the user before proceeding.

Macros in the macro library are lost when PCbug11 is terminated. For
this reason it is possible to store macro libraries on disk and load
them again when required by PCbug11. Macros are stored on disk in a
special text format. The files may be edited by text editors provided
the special format is always obeyed. When macros are stored after being
defined from within PCbug11 this special format is automatically
generated. When a macro library file is loaded all macros within that
file are loaded and added to the current macro library.

It is possible to have macros refer to other macros in their definition.
This means that a macro can be called by another macro as if it were a
standard PCbug11 command. This nesting of macros is allowed to be up to
5 levels deep. This means of course that a macro should never call
itself.

 Macros can also be passed parameters. That is, a macro may be defined
with certain parameters left as blanks to be filled in later. When the
macro is called the parameters called with it are used to fill the
blanks in the definition. Parameters are defined by using the "@"
character followed by a number to indicate which parameter is to be
used. @0 indicates the first parameter passed, @1 the second up to @9
which is the last parameter. Macros will not accept parameter numbers
greater than 9.

7.1.1 Defining Macros

Macros are defined in two ways. Firstly, the macro may be defined or
edited within PCbug11. For definition this involves simply typing DEFM
followed by the desired macro name. PCbug11 will then accept command
lines from the user and place these in the macro library under the macro
name. This is probably the quickest and easiest way to define macros.

Secondly, the macro may be defined within a text file. A standard format
is used. The definition of this format is under the DEFM command in
section 6.2.2. The format is very simple. The first line of the macro
must contain the reserved word DEFM followed by the name of the macro
being defined. This must be followed by a line containing the word BEGIN
on its own. After this any number of lines may be entered containing
PCbug11 commands. It is usual to proceed these lines by a tab or space
character. The macro definition is terminated by the reserved word END.
Another macro may be defined immediately following this line.

As described before parameters may be passed into a macro. They replace
special symbols according to their position in the macro command. The
parameter positions are defined by the @ symbol followed by a number
from 0 to 9. The parameter expressed first on the macro command line
replaces the @0 symbol. The second parameter replaces the @1 symbol.

For example, suppose a macro named RUNIT has been defined which uses two
parameters. The definition of RUNIT is:

          DEFM RUNIT   {Macro definition}
          BEGIN
               LOADS @0   {Load S-record whose name is 1st parameter}
               VERF @0    {Verify the S-record}
               G @1       {Run a program at the second parameter}
          END

Comments are enclosed in {} and are ignored and thrown away by PCbug11.

This macro can now be used to automatically load and verify and run a
program with one simple command. To load, verify and run an S-record
called TRYIT.S19 and run it from address $E000 simply type :

          RUNIT TRYIT $E000

Macros may be loaded automatically when PCbug11 is run from the DOS
prompt. This is done by placing the name of the macro library file on
the command line after the talker/boot option. If there is a macro
within this file called "AUTOSTART" then this macro is run automatically
before the user begins working. This is very useful where the user has
to run certain commands before using the hardware. Parameters may be
passed to the AUTOSTART macro by enclosing them in brackets () in the
PCbug11 command line immediately following the macro= option.

Due to the way PCbug11 stores macros internally, it is possible for a
macro to exist which does not contain any commands. The definition for
such a macro would be:

DEFM macro1
BEGIN
END

Macros like this are termed null macros. They can be run, saved, deleted
etc. like any other macro. They can be defined as breakpoint macros.
Null macros are normally used in development work when a macro is
required, but its exact operation is unclear. The user would therefore
define a macro, but leave it null - basically as a reminder.

7.1.2 Editing Macros

Macros may be edited by two methods. Firstly, the EDITM command may be
used. This allows the user to alter a macro from within PCbug11. This is
a full screen editor and is limited to having 10 lines on show at any
one time. This should be enough for most operations. The command set of
the editor is given in section 6.2.2 under EDITM.

Secondly, macros may be edited using a text editor and an ASCII file.
This allows the user to use the editor of his own choice. The text file
has an additional advantage in that comments may be included in the
file.  Macros in text files may be regarded as 'source' files for
PCbug11. In fact macros are run using an interpretive system (no
compilation is needed), but text files are easier to maintain than
libraries created in PCbug11 itself. Note that by using the DOS command
the user may work on macro text files without having to exit and restart
PCbug11.

Bear in mind that although macros may be saved from PCbug11, any
comments which existed in a library previously loaded are discarded.
This means that if a macro file is loaded (including comments) and then
saved then the comments in the original file will be lost.

7.1.3 Listing and Clearing Macros

In addition to their creation and saving, macros can also destroyed and
listed.

Macros are stored dynamically in the PC memory. That means that they
will only use as much memory as they need. Eventually, the user may find
that the PC runs out of memory. This is indicated by the fact that
macros may no longer be defined or loaded into the program. At this
point it may be necessary to delete some macros to make way for more.
Macros which are deleted are removed from memory and therefore should be
saved in a disk file using the SAVEM command if they are needed later.

Macros may be deleted in two ways. Firstly, all macros may be removed at
the same time. This is achieved by using the CLRM command. No check is
made by PCbug11 before this is done.

Secondly, a single macro may be deleted using the DELM command.

Note that if a macros is loaded which has the same name as a macro
already existing then the current macro is replaced by the new one. This
is not true of the definition (DEFM) of a new macro when a check with
the user is made.
7.2 Using Trace and Breakpoints

A useful feature in any development system is the ability to stop a
program when a certain address is reached. An associated feature is to
stop the program after it has executed the current command. These
features are normally termed breakpointing and tracing.

A breakpoint is placed at a certain point in the program by the user to
allow the examination of internal variables etc. When the program
reaches that point it will stop. This feature may be implemented in
several different ways. In PCbug11 breakpoints are created by using the
SWI (software interrupt) command of the 68HC11. When the program
executes a SWI an interrupt is caused which allows PCbug11 to regain
control of the HC11. This has two main implications.

For PCbug11 to be able to insert a breakpoint, the memory containing the
program must be alterable. PCbug11 simply replaces the opcode at the
address of interest with the SWI opcode. If the memory containing the
program is ROM then no breakpoints can be installed. In fact PCbug11
will warn of this, but will run the program anyway.

In the second place, PCbug11 must be able to alter the SWI interrupt
vector. Again if this is in ROM then no breakpoints maybe implemented.
This also means that the user is inhibited from using SWIs in his
program - at least in a real time sense. PCbug11 will remember what the
user has set the SWI vector to and if an SWI is encountered which is not
intended to be a breakpoint then PCbug11 will cause the program to jump
to he location indicated by the user SWI vector. This interference
causes a delay in the response to a user SWI. If no breakpoints are
installed then no delay will be experienced (above the normal latency).

Breakpoints are created by using the BR command. As soon as the
breakpoint is specified PCbug11 will change the SWI vector to a new
value for its own use and will store the user's SWI. The breakpoint
itself will only be placed into the program when the program is run. The
user opcode at the address of interest is read and stored by PCbug11.
Multiple breakpoints may be specified and all will be written into the
user program when it is run. As long as breakpoints exist the SWI vector
will be reserved by PCbug11.

When a breakpoint is reached by the program a small program is run by
the HC11. This informs PCbug11 that an SWI has been reached. PCbug11
checks to see whether this is a breakpoint or not. If it is then a
message is displayed on the screen of the PC and a macro may be run if
necessary.  At this point PCbug11 will display the BREAK status. Note
that the SWI will remain in the program until a stop S instruction has
been executed.

If the program exists in EEPROM or battery backed RAM then it is
possible that the SWI vector and the SWI opcodes could be left in the
memory. The SWI vector will be left if the hardware is powered down
while breakpoints still exist. SWIs would be left in memory if a stop S
has not been executed, after the program has been run, before the
hardware is powered down.

Tracing is very similar to breakpointing. In practice it may be
desirable to step through  a program instruction by instruction. It is
possible to do this by breakpoints. This involves placing a breakpoint
at the address immediately following the assembly command to be
executed. This would require a large amount of user involvement and so
PCbug11 can do this automatically. This is achieved by the trace command
T.

This is an extremely complex operation for PCbug11 to perform and
therefore can be a noticeably slower process. The reason is that PCbug11
must find for itself the address of the next opcode in the program. This
involves disassembling the opcode at the current address and deciding
how many bytes follow it. The process is complicated if the opcode is a
jump and even more so if a branch. In normal cases an SWI replaces the
next opcode in the program. For a jump the destination opcode is
replaced. For a branch two opcodes have to be replaced. The one
following the branch instruction and the one at the destination of the
branch.

Once the SWI has been placed in memory, PCbug11 will run the program.
The second instruction it sees will be an SWI and so the program will be
stopped. Again PCbug11 must be able to amend the contents of the SWI
vector and the program memory. A macro may be specified which will be
executed when the trace command hits a trace SWI. This macro must be
called TRACE and can contain whatever the user requires. Typically the
macro would disassemble the current instruction and perhaps read the
registers. The macro can also contain the trace command T itself. In
this case the program would step through all its instructions until
stopped by the user or it hits a self loop

The self loop condition occurs when a program jumps or branches to the
location it is already at. In this case it is pointless to perform a
trace and so the program continues to run and displays the status TRACE
until stopped by the user (S command) or the branch condition is
met/failed.

7.3 Talkers in EEPROM or External Memory

The usual approach when using PCbug11 is to use a boot option. Here the
talker program is downloaded every time the board is used. This has two
main disadvantages. Firstly, the transfer of the talker from the PC to
the board may go wrong and the talker will not work, and secondly, this
form of talker uses the HC11's internal RAM. On some versions this RAM
is limited to 256 bytes or less and when the stack usage and the
interrupt vectors are considered, there is very little room at all for
user programs or data in the RAM.

An alternative approach to this is to install the talker in the on-chip
EEPROM of the HC11 or in an external memory. Then whenever the package
is run it is not necessary to download the talker program to the board.
Additionally, since the talker does not reside in RAM the only areas
which the user may not use are the stack area and the interrupt vectors
(for bootstrap mode).

Talkers which reside in EEPROM are loaded by first booting up the HC11
as normal. Then the EEPROM area must be defined. Then the talker must be
installed using the LOADS instruction. It is probably best, next to
verify the installation using the VERF command. Once verified correctly
the talker is ready to use. The user should terminate PCbug11 and run it
again selecting the correct .MAP file instead of the usual boot option
(see section 7.5).

A special talker is available which already uses the internal EEPROM.
This is called TALKEREE.

It is important that two files are available when using this option.
These are TALKEREE.S19 and TALKEREE.MAP. The .S19 file is the S record
format of the talker to be installed in EEPROM - this must be in the
user's current directory. The .MAP file is a list of addresses which
PCbug11 uses to ensure good communication with the board. The
information contained in the .MAP file is normally handled internally by
PCbug11 when the boot option is used. The .MAP file must also be in the
user's current directory.

For example, to program the talker into EEPROM on a 68HC11E9 the
following macro could be used:

          DEFM AUTOSTART      {Run this macro automatically}
          BEGIN
               MS $1035 0     {Clear BPROT register - not needed on A8}
               EEPROM $B600 $B7FF  {Enable EEPROM algorithm}
               LOADS TALKEREE {Program talker into EEPROM}
               VERF TALKEREE  {Verify programming was OK}
               QUIT Y    {Exit PCbug11}
          END

If the above macro is saved in a file called STARTUP.MCR then the
following sequence can be followed.

     1/   Startup PCbug11 by typing: PCBUG11 -E STARTUP
     2/   Reset board.
     3/   Startup PCbug11 by typing : PCBUG11 TALKEREE

The EEPROM talker is now running.

NOTE 1: If any errors are displayed while running the macro then stop
the macro by hitting S (capital only) and correct the errors.

NOTE 2: This approach leaves most of the RAM free for user programs. The
default stack for TALKEREE is at $3F, so avoid use of the RAM at
addresses less then this address (i.e. between $00 and $3F). The user
can move the stack by modifying the source file TALKEREE.ASC and then
assembling it using ASMHC11 to produce a new stack value. This would
then have to be reloaded using the above sequence. The symbol to alter
is called STACK.

NOTE 3: The interrupt vector jumps are contained from $C4 to $FD and are
initialised to 'safe' values for PCbug11. The user can modify these JMP
instructions but remember that PCbug11 uses interrupts - XIRQ normally -
so do not modify this jump. In any case user program code should not
fill this area. A good idea may be to set up the required interrupt
vectors and then run the PROTECT command (see 6.2.2).

7.4 Programming EPROM (711) Parts

It is possible to program 68HC711 EPROM parts using this package. The
hardware must be configured as follows: 
               Do not connect XIRQ to PD0/SCI Rx
               Place the part in bootstrap mode and pull IRQ to Vdd
               Connect Vdd to the chip
               Connect Vpp to the XIRQ pin via a 100 resistor

NOTE: DO NOT CONNECT ANY Vpp VOLTAGE UNLESS Vdd IS CONNECTED. FAILURE TO
FOLLOW THIS SEQUENCE WILL CAUSE THE CHIP TO BE DESTROYED.

Attach Vdd to your board and startup PCbug11 as follows:

PCBUG11 -E/D/K      (For 711E9/711D3/711K4)

After ensuring that the board is working normally and that Vdd is
applied then apply Vpp to the Vpp terminal on the board.

Type commands:

EPROM $D000 $FFFF        To define the EPROM memory range
LOADS <filename>         Load the S record file to be programmed
VERF <filename>          To verify programming is successful

Once the part has been successfully program remove Vpp BEFORE Vdd.



 7.5 Designing New Talkers

It is possible and sometimes desirable to redesign or rewrite a talker
for a particular application. Occasionally, new HC11s are announced
whose behaviour after reset in bootstrap mode is slightly different to
normal (viz 68HC11D3). In such cases the bootstrap talker would need to
be rewritten. In practice this will normally be done by Motorola and so
it would be wise to check that the program has not already been amended
before proceeding to change a bootstrap talker.

However, ROMed talkers are more likely to require customisation by the
user. Here PCbug11 requires two files to be created. Firstly, the talker
itself must be supplied/modified and loaded into external memory.
Secondly, a file called a mapfile containing the addresses of several
key talker program routines. Together these allow PCbug11 to operate
with any customised talker. The .MAP and .ASC files for TALKEREE should
be used as templates when creating new ROMed talkers. By sticking to
conventions obeyed there the user should avoid any major problems.

Boot talkers may be customised by modifying the source file for the most
appropriate TALKXX.ASC file in TALKSRC or TALKSRCX. The new binary
download file is created by using the ASMHC11 assembler with the ;B
option. A typical command line would be :

     ASMHC11 TALKXX ;B

This will search for the TALKXX.ASC file and create a download file with
extension .BOO. If the file actually uses the XIRQ interrupt then the
filename should be renamed to a .XOO file to avoid confusion.
Appendix A - Circuit Diagram and Components List

The  hardware required for use with the PCbug11 software is exactly the
same as the hardware described on the Motorola application note AN1010,
with one addition. This is that the XIRQ pin should be attached to the
PD0/Rx pin on the processor (except when programming EPROM). This means
that the talker software can use the highest level interrupt available
for communications.

The hardware places the part in bootstrap mode using the mode pins and
the SCI communications port is translated to RS232 voltage levels using
a MC145407 chip or equivalent. An oscillator or crystal is also
required. Pulling up the IRQ pin will improve reliability. Pulling up
other input pins will reduce current supply but is not necessary when
working on the bench.

If the user has an alternative method of translating the voltage levels
then the MC145407 solution could be replaced. Incidentally, the
application note describes a simple program which does a much simpler
task than PCbug11, but uses exactly the same principles and may provide
interesting background reading for the user.

A.A Suitable hardware platforms

Motorola currently supplies two boards which may be used directly with
PCbug11. The D3 programmer board which may be used directly and the EVBU
board which requires the addition of one link to place the part into
bootstrap mode. There may be other suitable boards.

Note that the key elements are to place the part into bootstrap mode and
to have access to the SCI.

Appendix B - PCbug11 Error messages

There are three levels of error reporting within PCbug11:

     1/ Errors which report a failed operation

     2/ Errors which indicate a failed communication

     3/ Errors which report a bad command string

Errors reported by the ASM command are explained in section 6.2.2.

B.1 Operation Errors

These are displayed on the main window and indicate that the operation
has failed due to normal system behaviour. For example, trying to load a
macro called TRYIO and that file does not exist in the directory. This
returns an error message. Similarly, a verify may fail if an area of
EEPROM is not defined. These errors indicate that the operation has
failed because the user has not properly prepared the system. If it is
possible the error message will indicate why the operation has failed,
but this is not always possible.

B.2 Communications Errors and other Fatal Errors

Communications are a fundamental part of PCbug11. Unfortunately, without
due care, they can also be a troublesome part. Errors are reported in
two ways. Firstly, a message is displayed in the error window which
indicates which communication failed. This is displayed in red on colour
screens. A message displayed in this way may alternatively indicate a
failed operation. In either case the message will remove itself from the
screen after a few seconds or can be removed by hitting any key.

As the operation in progress may be a subset of the command which the
user tried to run, the message may not always be meaningful. For this
reason an additional message may be printed just below the register
window (in yellow) which indicates which command actually failed. This
has the form:

          Last error : <command> failed

where <command> is the command which the user tried to run.

If these errors persist, something is seriously wrong, please refer to
section 3.3.

In detail the error messages are:-

1/ Can't find .MAP file       PCbug11 can't find the map file associated
with the filename in the command line. This must in the PCBUG11
directory under a sub-directory called TALKMAP. The file must have the
extension .MAP. This error is only shown when starting or RESTARTing
PCbug11.

2/ Comms fault: <operation> terminated       <operation> is Register
read, Register write, Memory read, Memory write. This indicates that the
operation indicated has failed. These four basic operations are used to
implement many of PCbug11's commands and so an additional Last error
message is also displayed so that the user can determine exactly which
command has failed. The operation has failed because  communications
with the HC11 are not working. In addition, PCbug11 has been unable to
recover from this failure.

3/ Memory set error      This error indicates that PCbug11 has been
unable to set the requested memory location. This may be because the
memory is not working properly or perhaps has not been enabled as EEPROM
if that is required. The last error message will also indicate the
error.

4/ Memory write at <address> failed : please retry     This is related
to the Memory set error and indicates that the memory set operation at
the indicated address has failed. The message please retry indicates
that despite the error PCbug11 has not lost communication with the HC11.

5/ Comms fault : Memory write at <address> terminated  This indicates
that a write to <address> has not been completed and that communications
with the HC11 have been lost. This may occur if the memory write
destroyed part of the talker or the current Baud rate or in some other
way caused the HC11 to abort normal operation.

6/ Communications Synchronised     This indicates that PCbug11 is
communicating normally with the HC11. It is normally displayed after a
<CTRL> R command.

7/ Communications fault  Indicates that PCbug11 is unable to establish
communication with the HC11. Normally displayed after a <CTRL> R
command.

8/ Memory read failed : please retry    PCbug11 lost communication with
the HC11 while reading memory. However, it did re-establish
communications afterwards. The error could be displayed after the <ESC>
key is pressed during a memory read operation.


B.3 Command Errors

Command errors appear on the same line as the command which has just
been entered and indicate that PCbug11 is unable to process the
instruction as typed. There are three types of command error as follows:

     Command Error  This is returned when a command is entered which is
                    neither a PCbug11 command nor a currently defined
                    macro.

     Operand Error  This is returned when the operand of a command is
                    incorrect. See the command list section 6.2.2 for
                    the correct operands of each command.

     Range Error    This is returned when a command which includes a
                    range of addresses has exceeded the maximum range
                    allowed.
Appendix C - PCbug11 Disk Contents

PCbug11 comes supplied on 1 disk. The contents are as follows:

Disk      PCBUG11.EXE+   PCbug11 program
          PCBUGRTN.EXE+  Return program - user definable
          CODES.P11+     Mnemonic tables for assembly/disassembly
          OFFSETS.P11+   Mnemonic tables for assembly/disassembly
          ASMHC11.EXE    Absolute assembler program
          CONVERT.EXE    Program which converts older macro library
                         files to V3.0 text macro files. This program
                         is only used if the user has macro files
                         generated under old versions of PCbug11.
          TALK??.BOO     Talkers using SCI interrupt
          TALK??.XOO     Talkers using XIRQ interrupt

          PCbug11.HLP    This file contains all the help details for
                         PCbug11. The HELP feature will not work
                         unless this file is in the same directory
                         as PCBUG11.EXE
          TALKSRC        This directory contains the source files and
                         S-records of all the talkers which can be
                         loaded into EEPROM/EPROM and use the
                         SCI interrupt.
          TALKSRCX       This directory contains the source files and
                         S-records of all the talkers which can be
                         loaded into EEPROM/EPROM and use the
                         XIRQ interrupt.



+ PCbug11 will not work unless these files/directories are all in the
same directory
Appendix D - Software Version Information

This manual is based upon V3.20 of PCbug11. Periodically, this software
may be updated and enhanced. Information on the latest version with
respect to V3.20 may be included on this disk.
